> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.reka.ai/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.reka.ai/_mcp/server.

# Chat with Videos

POST https://vision-agent.api.reka.ai/v2/chat
Content-Type: application/json

Reference: https://docs.reka.ai/vision/api-reference/chat/chat-with-videos

## Authentication

- `X-Api-Key` header (required) — API key authentication via X-Api-Key header
- `Authorization` header (bearer token, required) — Bearer token authentication via Authorization header

## Request

### Headers

- `X-Enable-Overwrite-Metering` (string, optional, nullable)

### Body (application/json)

This endpoint expects a V2ChatRequest.

- `messages` (list of ChatMessage, required) — Conversation history. The last message must be from the user.
- `context` (list of ChatVideoContext, required) — Videos to analyze. Each entry references a video, optionally with a time range for visual analysis. At least one required.

## Response

### 200

Successful Response

- `response` (string, required) — The answer to the user's question about the video
- `model` (string, required) — LLM model that generated the response

## Types

### ChatMessage

- `role` (enum, required) — Message author: 'user' for questions, 'assistant' for prior answers
  - Allowed values: `user`, `assistant`
- `content` (string, required) — Message content

### ChatVideoContext

- `video_id` (string, required) — The video to analyze
- `start` (double, optional, nullable) — Start of time range in seconds. When provided, enables visual analysis (frame extraction). Typically from search_videos results.
- `end` (double, optional, nullable) — End of time range in seconds. If omitted and start is set, defaults to start + 10 seconds (clamped to video duration).

## Examples

**Request**

```json
{
  "messages": [
    {
      "role": "user",
      "content": "string"
    }
  ],
  "context": [
    {
      "video_id": "string"
    }
  ]
}
```

**Response**

```json
{
  "response": "string",
  "model": "string"
}
```

**SDK Code**

```python
import requests

url = "https://vision-agent.api.reka.ai/v2/chat"

payload = {
    "messages": [
        {
            "role": "user",
            "content": "string"
        }
    ],
    "context": [{ "video_id": "string" }]
}
headers = {
    "X-Api-Key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://vision-agent.api.reka.ai/v2/chat';
const options = {
  method: 'POST',
  headers: {'X-Api-Key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"messages":[{"role":"user","content":"string"}],"context":[{"video_id":"string"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://vision-agent.api.reka.ai/v2/chat"

	payload := strings.NewReader("{\n  \"messages\": [\n    {\n      \"role\": \"user\",\n      \"content\": \"string\"\n    }\n  ],\n  \"context\": [\n    {\n      \"video_id\": \"string\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-Api-Key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://vision-agent.api.reka.ai/v2/chat")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-Api-Key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"messages\": [\n    {\n      \"role\": \"user\",\n      \"content\": \"string\"\n    }\n  ],\n  \"context\": [\n    {\n      \"video_id\": \"string\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://vision-agent.api.reka.ai/v2/chat")
  .header("X-Api-Key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"messages\": [\n    {\n      \"role\": \"user\",\n      \"content\": \"string\"\n    }\n  ],\n  \"context\": [\n    {\n      \"video_id\": \"string\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://vision-agent.api.reka.ai/v2/chat', [
  'body' => '{
  "messages": [
    {
      "role": "user",
      "content": "string"
    }
  ],
  "context": [
    {
      "video_id": "string"
    }
  ]
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-Api-Key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://vision-agent.api.reka.ai/v2/chat");
var request = new RestRequest(Method.POST);
request.AddHeader("X-Api-Key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"messages\": [\n    {\n      \"role\": \"user\",\n      \"content\": \"string\"\n    }\n  ],\n  \"context\": [\n    {\n      \"video_id\": \"string\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-Api-Key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "messages": [
    [
      "role": "user",
      "content": "string"
    ]
  ],
  "context": [["video_id": "string"]]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://vision-agent.api.reka.ai/v2/chat")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```